# copy from install_dir to binary dir in case we do not do packaging which does it already
# not necessary when we use manifest and install the deps directly to binary dir

include(CMakePrintHelpers)

include("@CMAKE_SOURCE_DIR@/cmake_modules/CFS_macros.cmake")
assert_not_empty(@DEPS_INSTALL@)
assert_not_empty(@LIB_SUFFIX@)

set(CMAKE_BINARY_DIR @CMAKE_BINARY_DIR@)
set(DEPS_INSTALL @DEPS_INSTALL@)
set(LIB_SUFFIX @LIB_SUFFIX@) # shall be "lib"

assert_set(DEPS_INSTALL)
assert_set(LIB_SUFFIX)

# we copy only include and the lib dir

# cmake file() with subdirectories is a pain :( use cmake -E
execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${DEPS_INSTALL}/include ${CMAKE_BINARY_DIR}/include
  RESULT_VARIABLE rv
  OUTPUT_VARIABLE ov
  ERROR_VARIABLE ev )

if(NOT "${rv}" STREQUAL "0")
  message(FATAL_ERROR "could not copy ${DEPS_INSTALL}/include to ${CMAKE_BINARY_DIR}/include: out=${ov} err=${ev}")
endif()

# usually we build into lib and install to lib
# e.g. suitesparse uses either lib or lib64 depending on the system (only centos6 is lib64 all other seem lib)
# hence we check if in install is lib or lib64 and copy to lib. 
# Copying from a non-exisiting source creates an error
if(IS_DIRECTORY ${DEPS_INSTALL}/lib64)
  set(_SOURCE ${DEPS_INSTALL}/lib64)
elseif(IS_DIRECTORY ${DEPS_INSTALL}/lib)
  set(_SOURCE ${DEPS_INSTALL}/lib)
else()
  message(FATAL_ERROR "neither ${DEPS_INSTALL}/lib64 nor ${DEPS_INSTALL}/lib is a directory")
endif()

# cmake file() with subdirectories is a pain :( use cmake -E
execute_process(COMMAND ${CMAKE_COMMAND} -E copy_directory ${_SOURCE} ${CMAKE_BINARY_DIR}/${LIB_SUFFIX}
  RESULT_VARIABLE rv
  OUTPUT_VARIABLE ov
  ERROR_VARIABLE ev )

if(NOT "${rv}" STREQUAL "0")
  message(FATAL_ERROR "could not copy ${_SOURCE} to ${CMAKE_BINARY_DIR}/${LIB_SUFFIX}: out=${ov} err=${ev}")
endif()
